<?php
/*
Plugin Name: Custom Comment Questions
Plugin URI: http://www.kaisercrazy.com
Description: Use your own questions for provide human.
Version: 0.1b
Author: Serkan Algur
Author URI: http://www.kaisercrazy.com
License: GPLv2
*/
if (preg_match('#' . basename(__FILE__) . '#', $_SERVER['PHP_SELF'])) {
				die('You are not allowed to call this page directly.');
}
function multilingual_ccq( ) {
				// Internationalization, first(!)
				load_plugin_textdomain('ccq', false, dirname(plugin_basename(__FILE__)) . '/languages');
				// Other init stuff, be sure to it after load_plugins_textdomain if it involves translated text(!)
}
add_action('init', 'multilingual_ccq');


$ccqCaptcha = new ccq_cap;

class ccq_cap {
    public $version = '0.1b';
    public $configFile = 'ccq.json'; // it's a json file
    public $errors=array();
    function ccq_cap() {
		add_action('comment_form', array("ccq_cap", "build_form"),100);
        add_action('admin_menu', array('ccq_cap', 'ccq_cap_menu'));
        add_action('admin_head', array('ccq_cap', 'ccq_cap_settings_toggle'));
        add_filter('preprocess_comment', array('ccq_cap', 'ccq_cap_verify'), 1);
        add_action( 'init', 'session_start' );
        add_action('wp_ajax_nopriv_ccq_cap_validate', array("ccq_cap", "ccq_cap_validate"));
	}

	# ----------------------------------------------------------------
	# Admin area
	# ----------------------------------------------------------------

    function ccq_cap_validate() {
        global $ccqCaptcha;
		global $user_ID;
		if( $user_ID ) {
            return $id;
        }
		session_start();
		$test_captcha_answer = $_GET['ccq_cap_answer'];
		$answer = $_SESSION['answer'];
		// Check if the input matches the answer
		if( $ccqCaptcha->validate_answer($test_captcha_answer, $answer) ) {
			echo "true";
		} else {
            echo "false";
        }
        die();
        
    }

    function ccq_cap_settings_toggle() { ?>
        <script type="text/javascript">
            jQuery().ready(function(){
                jQuery(".toggle").click(function(i) {
                    if(jQuery(this).hasClass('on')) {
                        jQuery(this).removeClass('on');
                        jQuery(this).addClass('off');
                        jQuery(this).val('off');
                        // buttons don't post to forms
                        jQuery("#settings_"+this.id).val('off');
                    } else {
                        jQuery(this).removeClass('off');
                        jQuery(this).addClass('on');
                        jQuery(this).val('on');
                        jQuery("#settings_"+this.id).val('on');
                    }
                });				
                jQuery("#addRow").click(function(i) {
                    var max_id=parseInt(jQuery("#max_id").val())+1;
                    var tableRow='<tr><td><input type="text" name="questions['+max_id+'][question]" class="all-options"></td><td> <input type="text" name="questions['+max_id+'][answer]" class="all-options"></td><td> <input type="text" name="questions['+max_id+'][qresume]" class="all-options"></td></tr>';
                    jQuery("#max_id").val(max_id);
                    jQuery('#customQuestions > tbody:last').append(tableRow);

                });
                jQuery(".delRow").click(function(i) {
                    var delId=this.id;
                    jQuery("#container"+delId).empty();
                });
								
				jQuery(".help").click(function(i){
					jQuery("#help").toggle('slow');
				});
            });
        </script>
    <?php
    }

    function ccq_cap_menu() {
	    if (is_super_admin()) {
		    add_options_page(__('Custom Comment Questions','ccq'),__('Custom Comment Questions','ccq'), 'edit_plugins', 'ccq_cap', array('ccq_cap', 'ccq_cap_admin'));
	    }
    }

    function ccq_cap_admin() {
        global $ccqCaptcha;

        $config_dir=dirname(__FILE__);
        $config_file=$config_dir.'/'.$ccqCaptcha->configFile;

        if(!is_writeable($config_file)) {
            $errors[]='<div id="message" class="error"><p>Your config file ('.$config_file.') isn\'t writeable so you can\'t change anything</p></div>';
            // I don't do anything with this yet
		    // wp_die(__('Your config file isn\'t writeable so you can\'t change anything') );
        }
        
        // see if we need to write to the config file
        if(strlen($_POST['updateForm']) > 0) {
            /* format of toggles:
            $config['settings']['addition']='on';
            $config['settings']['multiplication']='on';
            
            format of questions:
            $config['questions'][0]['question']='What color is the sky on a clear day?';
            $config['questions'][0]['answer']='blue';
             */

            foreach($_POST as $var => $val) {
                // this because I can't get jQuery to play with brackets
                if(strpos($var, 'settings_')===0) {
                    $setting=str_replace('settings_', '', $var);
                    $config['settings'][$setting]=$val;
                }
            }
            // weed out blank questions
            $dirty_config['questions']=$_POST['questions'];
			$i=0;
			foreach($dirty_config['questions'] as $var => $qna) {
			    if(is_array($qna)) {
			        if(strlen($qna['question']) > 0) {
			            $config['questions'][$i]['question']=$qna['question'];
			            $config['questions'][$i]['answer']=$qna['answer'];
						$config['questions'][$i]['qresume']=$qna['qresume'];
			            $i++;
			        }
			    }
			}

            $towrite=json_encode($config);
            $handle = fopen($config_file, 'w');
            if(fwrite($handle, $towrite)===FALSE) {
                echo '<div id="message" class="error"><p>'. __('failed writing config', 'ccq') .'</p></div>';
            }
			else {
				echo '<div id="message" class="updated"><p>' . __('Settings saved.') . '</p></div>';
			}
            fclose($handle);
        }

        // Usage of user levels by plugins and themes is deprecated. Use roles and capabilities instead. 
        // roles and capabilities not implemented yet
        // which means that basically anybody who logs onto the admin screen can use this.
        $json=file_get_contents($config_file);
        $config=json_decode($json, TRUE);
        // debug // print_r($config);
		require('ccqadmin.php');
    }

	# ----------------------------------------------------------------
	# Captcha form and validation
	# ----------------------------------------------------------------

    function build_form($id) {
        global $user_ID;
        global $ccqCaptcha;
        if( !$user_ID ) {
            // grab the config
            // select a random question and answer
            // set them in the session
            // display the question in the form
            $question_type=$ccqCaptcha->select_question();
            $func='tc_'.$question_type;
            $q_and_a=$ccqCaptcha->$func($config);
            $question=$q_and_a['question'];
			$qresume=$q_and_a['qresume'];
            $answer=$q_and_a['answer'];
            $_SESSION['answer']=md5($answer);
            

?>
			<style>
				.left{float:left;margin-left:3px;}
				#ccq_cap {margin-top:5px;padding:5px;}
				#ccq_cap input {max-width:110px;}
			</style>
			
            <div id="ccq_cap">
			<div class="ccq_cap_error" style="display:none;"><?php _e('Something Wrong','ccq'); ?></div>
            <?php echo $question; ?> <input id="ccq_cap_answer" type="text" maxlength="10" width="100" size="10" name="ccq_cap_answer"> <?php echo $qresume; ?>
				<br />
			</div>
				
            <script type="text/javascript">
            <?php 
            if($_POST['ccq_cap_error']=='true') { ?>
                document.getElementById("ccq_cap_error").style.display='block';
	            commentform = document.getElementById("commentform");
	            commentform.author.value = "<?php echo htmlspecialchars($_POST['author1']); ?>";
	            commentform.email.value = "<?php echo htmlspecialchars($_POST['email1']); ?>";
	            commentform.url.value = "<?php echo htmlspecialchars($_POST['url1']); ?>";
	            commentform.comment.value = "<?php $trans = array("\r" => '\r', "\n" => '\n');
	            echo strtr(htmlspecialchars($_POST['comment1']), $trans); ?>";
            <?php } ?>

            var ccq_cap_form=document.getElementById('ccq_cap');
            // var p2 = document.getElementsByClassName('form-submit')[0];
            var p2 = document.getElementById('submit');
            p2.parentNode.insertBefore(ccq_cap_form,p2);
            </script>

        <?php
        }
    }

    function ccq_cap_verify($id) {
        global $ccqCaptcha;
		global $user_ID;
		if( $user_ID ) {
            return $id;
        }
		session_start();
		$test_captcha_answer = $_POST['ccq_cap_answer'];
		$answer = $_SESSION['answer'];
		
		// Check if the input matches the answer
		if( $ccqCaptcha->validate_answer($test_captcha_answer, $answer) ) {
			return $id;
		}
        // handle this more gracefully
		wp_die('<strong>HATA</strong>: '.__('You may give wrong answer for security question.','ccq') .'<br /><a href="javascript: history.go(-1);">'. __('Go Back to Article'). '</a>');
    }

	# ----------------------------------------------------------------
	# Helper function(s)
	# ----------------------------------------------------------------

    function validate_answer ( $test, $answer ) {
        $encoded_test=strtolower(md5(trim($test)));

		if( $encoded_test == strtolower(trim($answer)) ) {
			return true;
		}
		return false;
    }

    function load_config() {
        global $ccqCaptcha;
        $config_dir=dirname(__FILE__);
        $config_file=$config_dir.'/'.$ccqCaptcha->configFile;
        $json=file_get_contents($config_file); 
        $config=json_decode($json, TRUE);
        return $config;
    }

    function select_question() {
        global $ccqCaptcha;
        // first find out who the contenders are
        $config=$ccqCaptcha->load_config();
        foreach($config['settings'] as $var => $val) {
            if($val=='on') {
                $list[]=$var;
            }
        }
        $choice=array_rand($list);
        return $list[$choice];
    }

    function tc_multiplication() {
        global $ccqCaptcha;
        $operator_phrase=array(''.__('times','ccq').'', '*');
        $key=array_rand($operator_phrase);
        $operator=$operator_phrase[$key];
        $nums = $ccqCaptcha-> return_numbers();
        $ret['question']= $nums[0].' '.$operator.' '.$nums[1].'?';
        $ret['answer']=$nums[0]*$nums[1];
        return $ret;
    }

    function tc_addition($config) {
        global $ccqCaptcha;
        $operator_phrase=array(''.__('plus','ccq').'', '+');
        $key=array_rand($operator_phrase);
        $operator=$operator_phrase[$key];
        $nums = $ccqCaptcha-> return_numbers();
        $ret['question']= $nums[0].' '.$operator.' '.$nums[1].'?';
        $ret['answer']=$nums[0]+$nums[1];
        return $ret;
    }

    function return_numbers() {
        $num[]=rand(2,9);
        $num[]=rand(2,9);
        return $num;
    }

    function return_verbal($number_arr) {
        // make your hash
        $number_hash=array(
            1=>'one',
            2=>'two',
            3=>'three',
            4=>'four',
            5=>'five',
            6=>'six',
            7=>'seven',
            8=>'eight',
            9=>'nine'
        );
        foreach($number_arr as $var => $val) {
            $ret[$var]=$number_hash[$val];
        }
        return $ret;
    }

    function tc_questions($config) {
        global $ccqCaptcha;
        $config=$ccqCaptcha->load_config();
        $questions=$config['questions'];
        $key = array_rand($questions);
        $ret = $questions[$key];
        return $ret;
    }
}
?>
